angular.module("roll_the_dice", ["ionic","ionMdInput","ionic-material","ionic.rating","ionicLazyLoad","roll_the_dice.controllers", "roll_the_dice.services", "pascalprecht.translate"])
	.run(function($ionicPlatform, $translate) {
		$ionicPlatform.ready(function() {
			if(window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}

			if(window.StatusBar) {
				StatusBar.styleDefault();
			}

			setTimeout(function() {
			}, 100);
			
			// get device language from cordova plugin and set translation
			if(typeof navigator.globalization !== "undefined") {
                navigator.globalization.getPreferredLanguage(function(language) {
                    $translate.use((language.value).split("-")[0]).then(function(data) {
                        console.log("SUCCESS -> " + data);
                    }, function(error) {
                        console.log("ERROR -> " + error);
                    });
                }, null);
            }
			
			
			//======admob code start=============
			var admobid = {};
			  // select the right Ad Id according to platform
			  if( /(android)/i.test(navigator.userAgent) ) { 
				  admobid = { // for Android
					  banner: 'ca-app-pub-4543000274312570/2006413843',
					  //interstitial: 'ca-app-pub-6869992474017983/1657046752'
				  };
			  } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
				  admobid = { // for iOS
					  //banner: 'ca-app-pub-6869992474017983/4806197152',
					  //interstitial: 'ca-app-pub-6869992474017983/7563979554'
				  };
			  } else {
				  admobid = { // for Windows Phone
					  //banner: 'ca-app-pub-6869992474017983/8878394753',
					  //interstitial: 'ca-app-pub-6869992474017983/1355127956'
				  };
			  }
		   
			if(window.AdMob) AdMob.createBanner( {
				adId:admobid.banner, 
				position:AdMob.AD_POSITION.TOP_CENTER, 
				autoShow:true
			} );
			//=======AdMob Code End=======

		});
	})


	.filter("to_trusted", ["$sce", function($sce){
		return function(text) {
			return $sce.trustAsHtml(text);
		};
	}])
	.filter("trustUrl", function($sce) {
		return function(url) {
			return $sce.trustAsResourceUrl(url);
		};
	})




.config(function($stateProvider, $urlRouterProvider,$sceDelegateProvider, $translateProvider) {
	
	// Domain Whitelist
	$sceDelegateProvider.resourceUrlWhitelist([
		"self",
		new RegExp('^(http[s]?):\/\/(w{3}.)?youtube\.com/.+$'),
		new RegExp('^(http[s]?):\/\/(w{3}.)?w3schools\.com/.+$'),
	]);
	$stateProvider
	.state("roll_the_dice",{
		url: "/roll_the_dice",
			abstract: true,
			templateUrl: "templates/roll_the_dice-side_menus.html",
			controller: "side_menusCtrl",
	})

	.state("roll_the_dice.about", {
		url: "/about",
		views: {
			"roll_the_dice-side_menus" : {
						templateUrl:"templates/roll_the_dice-about.html",
						controller: "aboutCtrl"
					},
			"fabButtonUp" : {
						template: '',
					},
		}
	})

	.state("roll_the_dice.dice", {
		url: "/dice",
		cache: false,	// set cache to false in order to clear view on each view change
		views: {
			"roll_the_dice-side_menus" : {
						templateUrl:"templates/roll_the_dice-dice.html",
						controller: "diceCtrl"
					},
			"fabButtonUp" : {
						template: '',
					},
		}
	})

	.state("roll_the_dice.how_to_play", {
		url: "/how_to_play",
		views: {
			"roll_the_dice-side_menus" : {
						templateUrl:"templates/roll_the_dice-how_to_play.html",
						controller: "how_to_playCtrl"
					},
			"fabButtonUp" : {
						template: '',
					},
		}
	})

	.state("roll_the_dice.settings", {
		url: "/settings",
		views: {
			"roll_the_dice-side_menus" : {
						templateUrl:"templates/roll_the_dice-settings.html",
						controller: "settingsCtrl"
					},
			"fabButtonUp" : {
						template: '',
					},
		}
	})

	$urlRouterProvider.otherwise("/roll_the_dice/dice");
	

	/*
	 *	Set and load translations
	 */
	$translateProvider.useStaticFilesLoader({
		prefix: 'languages/locale-',
		suffix: '.json'
	});
	//$translateProvider.uses('en');
	
	$translateProvider.preferredLanguage("en");
    $translateProvider.fallbackLanguage("en");
	$translateProvider.useSanitizeValueStrategy('sanitize');

	
});
