angular.module("roll_the_dice.controllers")

.controller("diceCtrl", function($scope,$rootScope,$compile,$state,$ionicScrollDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$ionicLoading,$ionicPopup,$ionicPopover,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$translate,$ionicPlatform){

    //$translate.use('de');

	$ionicHistory.clearCache().then(function(){ $state.go('roll_the_dice.dice') })

	$rootScope.page_id = "dice" ;
	$scope.scrollTop = function(){
		$ionicScrollDelegate.$getByHandle("top").scrollTop();
	};
	// open external browser
	$scope.openURL = function($url){
		window.open($url,"_system","location=yes");
	};
	// open AppBrowser
	$scope.openAppBrowser = function($url){
		window.open($url,"_blank","closebuttoncaption=Done");
	};
	// open WebView
	$scope.openWebView = function($url){
		window.open($url,"_self");
	};

	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);


	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	$scope.rating = {};
	$scope.rating.max = 5;


  //  set settings object vars
	$scope.settings = {
		eyesSum: '',
		eyesKeptSum: '',
		sound: {},
		speakerLanguage: ''
	};

	// set globar object vars
	$scope.global = {
		temporaryDices: false,
		temporaryDiceEyes: '',
		temporaryDiceCount: '',
		diceInProgress: false,
		visibilityButton: false,
		shakerVisible: false,
	}

    //  dice eyes
	$scope.diceEyes = 6;
	$scope.settings.diceEyes = $scope.diceEyes;

	//  dice count
	$scope.diceCount = 2;
	$scope.settings.diceCount = $scope.diceCount;

     //  sum
     if (localStorage.getItem("showsum") === null) {
		$scope.settings.showSum = true;
		localStorage.setItem("showsum", true);
	  } else{
		$scope.settings.showSum = JSON.parse(localStorage.getItem("showsum"));
	  }
	
	  //  sounds - effects
	  if (localStorage.getItem("soundeffects") === null) {
		$scope.settings.sound.effects = true;
		localStorage.setItem("soundeffects", true);
	  } else{
		$scope.settings.sound.effects = JSON.parse(localStorage.getItem("soundeffects"));
	  }
	  
	//  sounds - read
	if (localStorage.getItem("soundread") === null) {
	  $scope.settings.sound.read = false;
	  localStorage.setItem("soundread", false);
	} else{
	  $scope.settings.sound.read = JSON.parse(localStorage.getItem("soundread"));
	}
	  
	//  shake
	if (localStorage.getItem("shake") === null) {
	  $scope.settings.shake = false;
	  localStorage.setItem("shake", false);
	} else{
	  $scope.settings.shake = JSON.parse(localStorage.getItem("shake"));
	}
  
    //  alerts
    if (localStorage.getItem("alertkeepdices") === null) {
		$scope.settings.alertKeepDices = false;
		localStorage.setItem("alertkeepdices", false);
    } else{
		$scope.settings.alertKeepDices = JSON.parse(localStorage.getItem("alertkeepdices"));
    }

	
	/*
	 *	roll the dice function
	 */
	$scope.dice = function() {
		
		if(!$scope.global.diceInProgress){
			
			$scope.global.diceInProgress = true;

			//  set vars based on temporary values if dices are kept
			//if ($scope.global.temporaryDices && $scope.global.temporaryDiceCount > 0) {
			//	$scope.diceEyes 	= localStorage.getItem("diceeyes");
			//	$scope.diceCount 	= $scope.global.temporaryDiceCount;
			//} else{
			//	$scope.diceEyes 				= localStorage.getItem("diceeyes");
			//	$scope.diceCount 				= localStorage.getItem("dicecount");
			//	$scope.global.temporaryDices 	= false;
			//	$scope.settings.eyesKeptSum 	= 0;
			//}
			$scope.global.temporaryDices 	= false;
			$scope.global.visibilityButton	= true;
			$scope.settings.eyesKeptSum 	= 0;
	
			// vars
			var maxDiceEyes = $scope.diceEyes;
			var randomDiceEyes;
			var i;
			var div;
			var dicedelay = 750;
			//var speakerLanguage;
			var currentLang;
			var eyesArray = [];
			//var eyesSum;
			var audio;
			
			/* hide dice shaker if visible */
			if($scope.global.shakerVisible){
				$('#dice-shaker').toggleClass('visible');
				$scope.global.shakerVisible = false;
			}
			
			// set language of speech
			if(typeof navigator.globalization !== "undefined") {
					navigator.globalization.getPreferredLanguage(function(language) {
						$scope.settings.speakerLanguage = language.value;
					}, null);
			} else{
				$scope.settings.speakerLanguage = "en-EN";	
			}
	
			//  clear content of dice element
			document.getElementById('dices').innerHTML = "";
	
			//  loop each dice
			for(i = 1; i <= $scope.diceCount; i++){
	
			  //  set timeout function to display dice result one after another
			  (function(i){
				
	
				//  display first dice instantly
				if(i > 1){
	
				  setTimeout(function () {
	
					//  get random dice eyes
					randomDiceEyes = getRandomInt(1, maxDiceEyes);
	
					//console.log('random: ' + randomDiceEyes);
	
					//  generate dices
					if (randomDiceEyes <= 6){
					  //  set class to show real dice eyes
					  div = '<div class="dice shake eyes-' + randomDiceEyes + '" id="dice-wrap"><span id="dice-' + i + '"></span></div>';
					} else{
					  //  set class to show number for higher dice eyes
					  div = '<div class="dice shake eyes-multitude" id="dice-wrap"><span id="dice-' + i + '"></span></div>';
					}
	
	
					// set temporary var to compile dynamically generated dom with ng-click funtion
					var temp = $compile(div)($scope);
					// append temp to element in order to get dynamically click function work
					angular.element(document.getElementById('dices')).append(temp);
					//document.getElementById('dices').innerHTML += div;
	
					//  set random dice eyes
					document.getElementById('dice-' + i).innerHTML = randomDiceEyes;
	
					//  add visible class to already shown dices
					setTimeout(function () {
						//document.getElementById('dice-' + i).className.replace(new RegExp('\\b' + shake + '\\b'),'');
						document.getElementById('dice-' + i).parentElement.className += " visible";
						//document.getElementById('dice-' + i).parentElement.setAttribute("ng-click", "touch()");
						//var diceElement = angular.element(document.getElementById('dice-' + i).parentElement);
						//diceElement.bind('click', $scope.onTouch());
					}, dicedelay);
	
					// speak eyes with speech synthesis api - https://blog.sperrobjekt.de/content/1000435-Sprachausgabe-im-Browser-Das-Speech-Synthesis-API.html
					if($scope.settings.sound.effects){
							
						// dice rolling sound
						audio = new Audio('audio/dice.mp3');
						audio.currentTime = 0.5;
						audio.play();
					  
					}

	
					// push eyes into eyes array
					eyesArray.push(randomDiceEyes);
	
					// get sum from all dice throws yet
					//eyesSum = eyesArray.reduce(function(pv, cv) { return pv + cv; }, 0);
					//$scope.settings.eyesSum = parseInt(eyesSum)+parseInt($scope.settings.eyesKeptSum);
					
					// get dices thrown and sort from higher number
					eyesArray.sort(sortNumber);
					$scope.settings.eyesSum = eyesArray.join("");
					
					//	21 is rolled
					if($scope.settings.eyesSum == 21){
						//speakResult($scope.settings.eyesSum, speakerLanguage);
						if($scope.settings.sound.effects){
							
							setTimeout(function () {
								// dice rolling sound
								audio = new Audio('audio/success.mp3');
								audio.currentTime = 0.5;
								audio.play();
							}, 800);
						  
						}
					}
					
					if($scope.settings.showSum){
	
						if(typeof navigator.globalization !== "undefined") {
								navigator.globalization.getPreferredLanguage(function(language) {
										currentLang = language.value.split("-")[0];
										if(currentLang == 'de'){
												document.getElementById("sum").innerHTML = 'Würfelergebnis: ' + $scope.settings.eyesSum;
										} else{
												document.getElementById("sum").innerHTML = 'Rolled dice result: ' + $scope.settings.eyesSum;
										}
								}, null);
						} else{
							document.getElementById("sum").innerHTML = 'Rolled dice result: ' + $scope.settings.eyesSum;
						}
						
					}
					
					// enable dicing when last dice is rolled
					if(i == $scope.diceCount){
						$scope.global.diceInProgress = false;
						$('#sum').removeClass('hidden');
					}
	
				  }, dicedelay * (i - 1));
	
				} else{
	
				  //  get random dice eyes
					randomDiceEyes = getRandomInt(1, maxDiceEyes);
	
					//console.log('random: ' + randomDiceEyes);
	
					//  generate dices
					if (randomDiceEyes <= 6){
					  //  set class to show real dice eyes
					  div = '<div class="dice shake eyes-' + randomDiceEyes + '" id="dice-wrap"><span id="dice-' + i + '"></span></div>';
					} else{
					  //  set class to show number for higher dice eyes
					  div = '<div class="dice shake eyes-multitude" id="dice-wrap"><span id="dice-' + i + '"></span></div>';
					}
	
					// set temporary var to compile dynamically generated dom with ng-click funtion
					var temp = $compile(div)($scope);
					// append temp to element in order to get dynamically click function work
					angular.element(document.getElementById('dices')).append(temp);
					//document.getElementById('dices').innerHTML += div;
	
					//  set random dice eyes
					document.getElementById('dice-' + i).innerHTML = randomDiceEyes;
	
					//  add visible class to already shown dices
					setTimeout(function () {
					  document.getElementById('dice-' + i).parentElement.className += " visible";
					}, dicedelay);
	
					// speak eyes with speech synthesis api - https://blog.sperrobjekt.de/content/1000435-Sprachausgabe-im-Browser-Das-Speech-Synthesis-API.html
					if($scope.settings.sound.effects){
							
					  // dice rolling sound
					  audio = new Audio('audio/dice.mp3');
					  audio.currentTime = 0.5;
					  audio.play();
					  
					}
					
					// push eyes into eyes array
					eyesArray.push(randomDiceEyes);
	
					//	display sum if dices where kept
					//if ($scope.global.temporaryDices && $scope.global.temporaryDiceCount == 1) {
					//	eyesArray = [];
					//	
					//	// get sum from all dice throws yet
					//	$scope.settings.eyesSum = parseInt(randomDiceEyes)+parseInt($scope.settings.eyesKeptSum);
					//	
					//	if($scope.settings.showSum){
					//
					//		if(typeof navigator.globalization !== "undefined") {
					//				navigator.globalization.getPreferredLanguage(function(language) {
					//						currentLang = language.value.split("-")[0];
					//						if(currentLang == 'de'){
					//								document.getElementById("sum").innerHTML = 'Würfelergebnis: ' + $scope.settings.eyesSum;
					//						} else{
					//								document.getElementById("sum").innerHTML = 'Rolled dice result: ' + $scope.settings.eyesSum;
					//						}
					//				}, null);
					//		} else{
					//			document.getElementById("sum").innerHTML = 'Rolled dice result: ' + $scope.settings.eyesSum;
					//		}
					//		
					//	}
					//	
					//}
					
					// enable dicing when last dice is rolled
					if ($scope.diceCount == 1) {
						setTimeout(function () {
							$scope.global.diceInProgress = false;
							$('#sum').removeClass('hidden');
						}, dicedelay);
						 
					}
				}
	
	
			  }(i));
	
	
			}
			
			
		} /* endif diceInProgress */
		

        // get random integer for dice eyes
        function getRandomInt(min, max) {
          return Math.floor(Math.random() * (max - min + 1) + min);
        }
		
		/* sort numbers */
		function sortNumber(a,b) {
			return b - a;
		}

    };
	
	
	/*
     *	Roll the dice on shake - if shake is enabled - requieres https://github.com/leecrossley/cordova-plugin-shake
     */
    $scope.onShake = function () {
		
		// Fired when a shake is detected
		//$scope.global.visibilityButton	= true;
		//
		///* hide dice shaker if visible */
		//if($scope.global.shakerVisible){
		//	$('#dice-shaker').toggleClass('visible');
		//	$scope.global.shakerVisible = false;
		//}
		//
		///*	roll the dice */
		//$scope.dice();
		
		 document.getElementById("dice-button").click();

    };

	  
    $scope.onError = function () {
		// Fired when there is an accelerometer error (optional)
		alert('Shake Error');
    };
	  
    // Start watching for shake gestures and call "onShake"
    // with a shake sensitivity of 40 (optional, default 30)
	// shake object only gets added on real phones, so here a little bypass
	if(window.shake){
		if($scope.settings.shake){
			shake.startWatch($scope.onShake, 30 , $scope.onError );
		}
	};
	//	stop shake listening when app is in pause mode (background)
	$ionicPlatform.on("pause", function(event) {
		if(window.shake){
			if($scope.settings.shake){
				// Stop watching for shake gestures
				shake.stopWatch();
			}
		};
	});
	//	start shake listening when app resumes from background
	$ionicPlatform.on("resume", function(event) {
		if(window.shake){
			if($scope.settings.shake){
				shake.startWatch($scope.onShake, 30 , $scope.onError );
			}
		};
	});


    /*
     *	reset kept dices and roll with new ones
     */
    $scope.newDices = function(){

		$scope.global.temporaryDices = false;

    };
    

	/*
     *	show alert dialog to inform user about keeping dices
     */
	//$scope.showAlert = function() {
	//	
	//	var titleText;
	//	var currentLang;
	//	
	//	//	set title
	//	if(typeof navigator.globalization !== "undefined") {
	//			navigator.globalization.getPreferredLanguage(function(language) {
	//					currentLang = language.value.split("-")[0];
	//					if(currentLang == 'de'){
	//							titleText = "Hinweis!";
	//					} else{
	//							titleText = "Please Notice!";
	//					}
	//			}, null);
	//	} else{
	//		titleText = "Please Notice!";
	//	}
	//	
	//	var alertPopup = $ionicPopup.alert({
	//			title: titleText,
	//			template: '<span style="display: block;text-align: center" translate="DICE_KEEP_ALERT_TEXT">Tap the dices to keep them.</span>',
	//			okType: 'button-balanced bg-dice'
	//	});
	//
	//	alertPopup.then(function(res) {
	//			//console.log('Thank you for not eating my delicious ice cream cone');
	//			localStorage.setItem("alertkeepdices", true);
	//	});
	//	
	//};
	//if(!$scope.settings.alertKeepDices){
	//	$scope.showAlert();
	//}
	
	
	/*
     *	hide / show dices
     */
    $scope.hideToggle = function(){
		
		/* show / hide shaker and sum */
		if(!$scope.global.shakerVisible){
			$('#dice-shaker').toggleClass('visible');
			$('#sum').toggleClass('hidden');
			$scope.global.shakerVisible = true;
		} else{
			$('#dice-shaker').toggleClass('visible');
			$('#sum').toggleClass('hidden');
			$scope.speakResult($scope.settings.eyesSum, $scope.settings.speakerLanguage);
			$scope.global.shakerVisible = false;
		}

    }
	
	
	/*
     *	read result out loud
     */
    $scope.speakResult = function(eyes, lang){
		
		/* read sum loud if shaker is released */
		if($scope.settings.sound.read){
				
			//console.log(eyes);
			//console.log(lang);
			
			// read dice eyes
			setTimeout(function () {
				
				// cordova text-to-speech plugin - https://github.com/vilic/cordova-plugin-tts
				if (window.cordova) {
					TTS
					  .speak({
							text: eyes,
							locale: lang,
							rate:0.75
						}, function () {
							//alert('success');
						}, function (reason) {
							//alert(reason);
					});
				}

		  }, 300);
		  
		}

    }


})
